=begin
#Opsgenie REST API

#Opsgenie OpenAPI Specification

OpenAPI spec version: 2.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.13

=end

require 'uri'

module OpsgenieSdk
  class PolicyApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Change Policy Order
    # Change execution order of the policy with given id
    # @param policy_id Id of the requested policy
    # @param body Change order payload
    # @param [Hash] opts the optional parameters
    # @option opts [String] :team_id TeamId of policy created if it belongs to a team
    # @return [SuccessResponse]
    def change_policy_order(policy_id, body, opts = {})
      data, _status_code, _headers = change_policy_order_with_http_info(policy_id, body, opts)
      data
    end

    # Change Policy Order
    # Change execution order of the policy with given id
    # @param policy_id Id of the requested policy
    # @param body Change order payload
    # @param [Hash] opts the optional parameters
    # @option opts [String] :team_id TeamId of policy created if it belongs to a team
    # @return [Array<(SuccessResponse, Fixnum, Hash)>] SuccessResponse data, response status code and response headers
    def change_policy_order_with_http_info(policy_id, body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyApi.change_policy_order ...'
      end
      # verify the required parameter 'policy_id' is set
      if @api_client.config.client_side_validation && policy_id.nil?
        fail ArgumentError, "Missing the required parameter 'policy_id' when calling PolicyApi.change_policy_order"
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling PolicyApi.change_policy_order"
      end
      # resource path
      local_var_path = '/v2/policies/{policyId}/change-order'.sub('{' + 'policyId' + '}', policy_id.to_s)

      # query parameters
      query_params = {}
      query_params[:'teamId'] = opts[:'team_id'] if !opts[:'team_id'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = ['GenieKey']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'SuccessResponse')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyApi#change_policy_order\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Create Policy
    # Creates a new policy
    # @param body Payload of created policy
    # @param [Hash] opts the optional parameters
    # @option opts [Object] :team_id TeamId of policy created if it belongs to a team
    # @return [CreatePolicyResponse]
    def create_policy(body, opts = {})
      data, _status_code, _headers = create_policy_with_http_info(body, opts)
      data
    end

    # Create Policy
    # Creates a new policy
    # @param body Payload of created policy
    # @param [Hash] opts the optional parameters
    # @option opts [Object] :team_id TeamId of policy created if it belongs to a team
    # @return [Array<(CreatePolicyResponse, Fixnum, Hash)>] CreatePolicyResponse data, response status code and response headers
    def create_policy_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyApi.create_policy ...'
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling PolicyApi.create_policy"
      end
      # resource path
      local_var_path = '/v2/policies'

      # query parameters
      query_params = {}
      query_params[:'teamId'] = opts[:'team_id'] if !opts[:'team_id'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = ['GenieKey']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'CreatePolicyResponse')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyApi#create_policy\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Delete Policy
    # Delete policy with given id
    # @param policy_id Id of the requested policy
    # @param [Hash] opts the optional parameters
    # @option opts [Object] :team_id TeamId of policy created if it belongs to a team
    # @return [SuccessResponse]
    def delete_policy(policy_id, opts = {})
      data, _status_code, _headers = delete_policy_with_http_info(policy_id, opts)
      data
    end

    # Delete Policy
    # Delete policy with given id
    # @param policy_id Id of the requested policy
    # @param [Hash] opts the optional parameters
    # @option opts [Object] :team_id TeamId of policy created if it belongs to a team
    # @return [Array<(SuccessResponse, Fixnum, Hash)>] SuccessResponse data, response status code and response headers
    def delete_policy_with_http_info(policy_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyApi.delete_policy ...'
      end
      # verify the required parameter 'policy_id' is set
      if @api_client.config.client_side_validation && policy_id.nil?
        fail ArgumentError, "Missing the required parameter 'policy_id' when calling PolicyApi.delete_policy"
      end
      # resource path
      local_var_path = '/v2/policies/{policyId}'.sub('{' + 'policyId' + '}', policy_id.to_s)

      # query parameters
      query_params = {}
      query_params[:'teamId'] = opts[:'team_id'] if !opts[:'team_id'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['GenieKey']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'SuccessResponse')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyApi#delete_policy\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Disable Policy
    # Disable the policy with given id
    # @param policy_id Id of the requested policy
    # @param [Hash] opts the optional parameters
    # @option opts [Object] :team_id TeamId of policy created if it belongs to a team
    # @return [SuccessResponse]
    def disable_policy(policy_id, opts = {})
      data, _status_code, _headers = disable_policy_with_http_info(policy_id, opts)
      data
    end

    # Disable Policy
    # Disable the policy with given id
    # @param policy_id Id of the requested policy
    # @param [Hash] opts the optional parameters
    # @option opts [Object] :team_id TeamId of policy created if it belongs to a team
    # @return [Array<(SuccessResponse, Fixnum, Hash)>] SuccessResponse data, response status code and response headers
    def disable_policy_with_http_info(policy_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyApi.disable_policy ...'
      end
      # verify the required parameter 'policy_id' is set
      if @api_client.config.client_side_validation && policy_id.nil?
        fail ArgumentError, "Missing the required parameter 'policy_id' when calling PolicyApi.disable_policy"
      end
      # resource path
      local_var_path = '/v2/policies/{policyId}/disable'.sub('{' + 'policyId' + '}', policy_id.to_s)

      # query parameters
      query_params = {}
      query_params[:'teamId'] = opts[:'team_id'] if !opts[:'team_id'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['GenieKey']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'SuccessResponse')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyApi#disable_policy\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Enable Policy
    # Enable the policy with given id
    # @param policy_id Id of the requested policy
    # @param [Hash] opts the optional parameters
    # @option opts [Object] :team_id TeamId of policy created if it belongs to a team
    # @return [SuccessResponse]
    def enable_policy(policy_id, opts = {})
      data, _status_code, _headers = enable_policy_with_http_info(policy_id, opts)
      data
    end

    # Enable Policy
    # Enable the policy with given id
    # @param policy_id Id of the requested policy
    # @param [Hash] opts the optional parameters
    # @option opts [Object] :team_id TeamId of policy created if it belongs to a team
    # @return [Array<(SuccessResponse, Fixnum, Hash)>] SuccessResponse data, response status code and response headers
    def enable_policy_with_http_info(policy_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyApi.enable_policy ...'
      end
      # verify the required parameter 'policy_id' is set
      if @api_client.config.client_side_validation && policy_id.nil?
        fail ArgumentError, "Missing the required parameter 'policy_id' when calling PolicyApi.enable_policy"
      end
      # resource path
      local_var_path = '/v2/policies/{policyId}/enable'.sub('{' + 'policyId' + '}', policy_id.to_s)

      # query parameters
      query_params = {}
      query_params[:'teamId'] = opts[:'team_id'] if !opts[:'team_id'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['GenieKey']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'SuccessResponse')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyApi#enable_policy\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Get Policy
    # Used to get details of a single policy with id
    # @param policy_id Id of the requested policy
    # @param [Hash] opts the optional parameters
    # @option opts [Object] :team_id TeamId of policy created if it belongs to a team
    # @return [GetPolicyResponse]
    def get_policy(policy_id, opts = {})
      data, _status_code, _headers = get_policy_with_http_info(policy_id, opts)
      data
    end

    # Get Policy
    # Used to get details of a single policy with id
    # @param policy_id Id of the requested policy
    # @param [Hash] opts the optional parameters
    # @option opts [Object] :team_id TeamId of policy created if it belongs to a team
    # @return [Array<(GetPolicyResponse, Fixnum, Hash)>] GetPolicyResponse data, response status code and response headers
    def get_policy_with_http_info(policy_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyApi.get_policy ...'
      end
      # verify the required parameter 'policy_id' is set
      if @api_client.config.client_side_validation && policy_id.nil?
        fail ArgumentError, "Missing the required parameter 'policy_id' when calling PolicyApi.get_policy"
      end
      # resource path
      local_var_path = '/v2/policies/{policyId}'.sub('{' + 'policyId' + '}', policy_id.to_s)

      # query parameters
      query_params = {}
      query_params[:'teamId'] = opts[:'team_id'] if !opts[:'team_id'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['GenieKey']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'GetPolicyResponse')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyApi#get_policy\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # List Alert Policies
    # Returns the list of alert policies
    # @param [Hash] opts the optional parameters
    # @option opts [Object] :team_id TeamId of policy created if it belongs to a team
    # @return [ListPoliciesResponse]
    def list_alert_policies(opts = {})
      data, _status_code, _headers = list_alert_policies_with_http_info(opts)
      data
    end

    # List Alert Policies
    # Returns the list of alert policies
    # @param [Hash] opts the optional parameters
    # @option opts [Object] :team_id TeamId of policy created if it belongs to a team
    # @return [Array<(ListPoliciesResponse, Fixnum, Hash)>] ListPoliciesResponse data, response status code and response headers
    def list_alert_policies_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyApi.list_alert_policies ...'
      end
      # resource path
      local_var_path = '/v2/policies/alert'

      # query parameters
      query_params = {}
      query_params[:'teamId'] = opts[:'team_id'] if !opts[:'team_id'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['GenieKey']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ListPoliciesResponse')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyApi#list_alert_policies\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # List Notification Policies
    # Returns the list of notification policies
    # @param [Hash] opts the optional parameters
    # @option opts [Object] :team_id TeamId of policy created if it belongs to a team
    # @return [ListPoliciesResponse]
    def list_notification_policies(opts = {})
      data, _status_code, _headers = list_notification_policies_with_http_info(opts)
      data
    end

    # List Notification Policies
    # Returns the list of notification policies
    # @param [Hash] opts the optional parameters
    # @option opts [Object] :team_id TeamId of policy created if it belongs to a team
    # @return [Array<(ListPoliciesResponse, Fixnum, Hash)>] ListPoliciesResponse data, response status code and response headers
    def list_notification_policies_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyApi.list_notification_policies ...'
      end
      # resource path
      local_var_path = '/v2/policies/notification'

      # query parameters
      query_params = {}
      query_params[:'teamId'] = opts[:'team_id'] if !opts[:'team_id'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['GenieKey']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ListPoliciesResponse')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyApi#list_notification_policies\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Update Policy
    # Update alert policy with given id
    # @param policy_id Id of the requested policy
    # @param body Payload of updated policy
    # @param [Hash] opts the optional parameters
    # @option opts [String] :team_id TeamId of policy created if it belongs to a team
    # @return [SuccessResponse]
    def update_policy(policy_id, body, opts = {})
      data, _status_code, _headers = update_policy_with_http_info(policy_id, body, opts)
      data
    end

    # Update Policy
    # Update alert policy with given id
    # @param policy_id Id of the requested policy
    # @param body Payload of updated policy
    # @param [Hash] opts the optional parameters
    # @option opts [String] :team_id TeamId of policy created if it belongs to a team
    # @return [Array<(SuccessResponse, Fixnum, Hash)>] SuccessResponse data, response status code and response headers
    def update_policy_with_http_info(policy_id, body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PolicyApi.update_policy ...'
      end
      # verify the required parameter 'policy_id' is set
      if @api_client.config.client_side_validation && policy_id.nil?
        fail ArgumentError, "Missing the required parameter 'policy_id' when calling PolicyApi.update_policy"
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling PolicyApi.update_policy"
      end
      # resource path
      local_var_path = '/v2/policies/{policyId}'.sub('{' + 'policyId' + '}', policy_id.to_s)

      # query parameters
      query_params = {}
      query_params[:'teamId'] = opts[:'team_id'] if !opts[:'team_id'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = ['GenieKey']
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'SuccessResponse')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PolicyApi#update_policy\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
