=begin
#Opsgenie REST API

#Opsgenie OpenAPI Specification

OpenAPI spec version: 2.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.13

=end

require 'uri'

module OpsgenieSdk
  class TeamMemberApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Add Team Member
    # Adds a member to team with given identifier
    # @param identifier Identifier of the team
    # @param body Request payload of added team member
    # @param [Hash] opts the optional parameters
    # @option opts [String] :team_identifier_type Type of the identifier. Possible values are &#39;id&#39; and &#39;name&#39;. Default value is &#39;id&#39; (default to id)
    # @return [SuccessResponse]
    def add_team_member(identifier, body, opts = {})
      data, _status_code, _headers = add_team_member_with_http_info(identifier, body, opts)
      data
    end

    # Add Team Member
    # Adds a member to team with given identifier
    # @param identifier Identifier of the team
    # @param body Request payload of added team member
    # @param [Hash] opts the optional parameters
    # @option opts [String] :team_identifier_type Type of the identifier. Possible values are &#39;id&#39; and &#39;name&#39;. Default value is &#39;id&#39;
    # @return [Array<(SuccessResponse, Fixnum, Hash)>] SuccessResponse data, response status code and response headers
    def add_team_member_with_http_info(identifier, body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TeamMemberApi.add_team_member ...'
      end
      # verify the required parameter 'identifier' is set
      if @api_client.config.client_side_validation && identifier.nil?
        fail ArgumentError, "Missing the required parameter 'identifier' when calling TeamMemberApi.add_team_member"
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling TeamMemberApi.add_team_member"
      end
      if @api_client.config.client_side_validation && opts[:'team_identifier_type'] && !['id', 'name'].include?(opts[:'team_identifier_type'])
        fail ArgumentError, 'invalid value for "team_identifier_type", must be one of id, name'
      end
      # resource path
      local_var_path = '/v2/teams/{identifier}/members'.sub('{' + 'identifier' + '}', identifier.to_s)

      # query parameters
      query_params = {}
      query_params[:'teamIdentifierType'] = opts[:'team_identifier_type'] if !opts[:'team_identifier_type'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = ['GenieKey']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'SuccessResponse')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TeamMemberApi#add_team_member\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Delete Team Member
    # Deletes the member of team with given identifier
    # @param identifier Identifier of the team
    # @param member_identifier User id or username of member for removal
    # @param [Hash] opts the optional parameters
    # @option opts [String] :team_identifier_type Type of the identifier. Possible values are &#39;id&#39; and &#39;name&#39;. Default value is &#39;id&#39; (default to id)
    # @return [SuccessResponse]
    def delete_team_member(identifier, member_identifier, opts = {})
      data, _status_code, _headers = delete_team_member_with_http_info(identifier, member_identifier, opts)
      data
    end

    # Delete Team Member
    # Deletes the member of team with given identifier
    # @param identifier Identifier of the team
    # @param member_identifier User id or username of member for removal
    # @param [Hash] opts the optional parameters
    # @option opts [String] :team_identifier_type Type of the identifier. Possible values are &#39;id&#39; and &#39;name&#39;. Default value is &#39;id&#39;
    # @return [Array<(SuccessResponse, Fixnum, Hash)>] SuccessResponse data, response status code and response headers
    def delete_team_member_with_http_info(identifier, member_identifier, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TeamMemberApi.delete_team_member ...'
      end
      # verify the required parameter 'identifier' is set
      if @api_client.config.client_side_validation && identifier.nil?
        fail ArgumentError, "Missing the required parameter 'identifier' when calling TeamMemberApi.delete_team_member"
      end
      # verify the required parameter 'member_identifier' is set
      if @api_client.config.client_side_validation && member_identifier.nil?
        fail ArgumentError, "Missing the required parameter 'member_identifier' when calling TeamMemberApi.delete_team_member"
      end
      if @api_client.config.client_side_validation && opts[:'team_identifier_type'] && !['id', 'name'].include?(opts[:'team_identifier_type'])
        fail ArgumentError, 'invalid value for "team_identifier_type", must be one of id, name'
      end
      # resource path
      local_var_path = '/v2/teams/{identifier}/members/{memberIdentifier}'.sub('{' + 'identifier' + '}', identifier.to_s).sub('{' + 'memberIdentifier' + '}', member_identifier.to_s)

      # query parameters
      query_params = {}
      query_params[:'teamIdentifierType'] = opts[:'team_identifier_type'] if !opts[:'team_identifier_type'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['GenieKey']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'SuccessResponse')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TeamMemberApi#delete_team_member\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
