=begin
#Opsgenie REST API

#Opsgenie OpenAPI Specification

OpenAPI spec version: 2.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.13

=end

require 'date'

module OpsgenieSdk
  class ActionMapping
    attr_accessor :action

    attr_accessor :extra_field

    attr_accessor :extra_field_for_mapped_action

    attr_accessor :mapped_action

    class EnumAttributeValidator
      attr_reader :datatype
      attr_reader :allowable_values

      def initialize(datatype, allowable_values)
        @allowable_values = allowable_values.map do |value|
          case datatype.to_s
          when /Integer/i
            value.to_i
          when /Float/i
            value.to_f
          else
            value
          end
        end
      end

      def valid?(value)
        !value || allowable_values.include?(value)
      end
    end

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'action' => :'action',
        :'extra_field' => :'extraField',
        :'extra_field_for_mapped_action' => :'extraFieldForMappedAction',
        :'mapped_action' => :'mappedAction'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'action' => :'String',
        :'extra_field' => :'String',
        :'extra_field_for_mapped_action' => :'String',
        :'mapped_action' => :'String'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      if attributes.has_key?(:'action')
        self.action = attributes[:'action']
      end

      if attributes.has_key?(:'extraField')
        self.extra_field = attributes[:'extraField']
      end

      if attributes.has_key?(:'extraFieldForMappedAction')
        self.extra_field_for_mapped_action = attributes[:'extraFieldForMappedAction']
      end

      if attributes.has_key?(:'mappedAction')
        self.mapped_action = attributes[:'mappedAction']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if @action.nil?
        invalid_properties.push('invalid value for "action", action cannot be nil.')
      end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if @action.nil?
      action_validator = EnumAttributeValidator.new('String', ['create', 'acknowledge', 'unacknowledge', 'snooze', 'escalate-to-next', 'add-note', 'add-responder', 'add-tags', 'remove-tags', 'close', 'delete', 'escalate', 'custom-action', 'assign-ownership', 'take-ownership', 'update-priority', 'update-description', 'update-message'])
      return false unless action_validator.valid?(@action)
      mapped_action_validator = EnumAttributeValidator.new('String', ['publish', 'create-incident', 'create-problem', 'update-description', 'update-priority', 'resolve-issue', 'resolve-ticket', 'add-work-info', 'close-incident', 'create', 'close', 'resolve', 'add-journal', 'in-progress-incident', 'resolve-incident', 'acknowledge', 'unacknowledge', 'create-service-ticket', 'add-discussion-note-to-ticket', 'add-resolution-note-to-ticket', 'add-internal-note-to-ticket', 'close-service-ticket', 'in-progress-ticket', 'custom-status', 'add-note', 'confirm-incident', 'set-status-to-closed', 'set-status-to-pending', 'set-status-to-resolved', 'create-ticket', 'add-public-note', 'add-private-note', 'set-status-to-open', 'create-issue', 'add-comment-to-issue', 'in-progress-issue', 'close-issue', 'issue-done', 'add-tag', 'create-conversation', 'set-status-to-completed', 'ack-alert', 'unmute-alert', 'send-to-channel', 'create-case', 'set-case-status-to-active', 'set-case-status-to-close', 'set-case-status-to-close-as-duplicate', 'post-action-to-oec', 'create-alert', 'close-alert', 'acknowledge-alert', 'unacknowledge-alert', 'acknowledgeSensor', 'setStatusToClosed', 'set-case-status-to-working', 'add-note-to-incident', 'assign-to-group', 'assign-to-user', 'assign-to-owner', 'send-to-custom-endpoint', 'acknowledge-notification', 'createEvent', 'createTag', 'createComment', 'updateSeverity', 'updateStatusToClosed', 'updateStatusToInProgress', 'create-incident-and-update-component-statuses', 'resolve-incident-and-update-component-statuses-back-to-operational', 'update-component-statuses', 'sendData', 'postToUrl', 'add-internal-note', 'public-reply', 'set-status-to-solved'])
      return false unless mapped_action_validator.valid?(@mapped_action)
      true
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] action Object to be assigned
    def action=(action)
      validator = EnumAttributeValidator.new('String', ['create', 'acknowledge', 'unacknowledge', 'snooze', 'escalate-to-next', 'add-note', 'add-responder', 'add-tags', 'remove-tags', 'close', 'delete', 'escalate', 'custom-action', 'assign-ownership', 'take-ownership', 'update-priority', 'update-description', 'update-message'])
      unless validator.valid?(action)
        fail ArgumentError, 'invalid value for "action", must be one of #{validator.allowable_values}.'
      end
      @action = action
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] mapped_action Object to be assigned
    def mapped_action=(mapped_action)
      validator = EnumAttributeValidator.new('String', ['publish', 'create-incident', 'create-problem', 'update-description', 'update-priority', 'resolve-issue', 'resolve-ticket', 'add-work-info', 'close-incident', 'create', 'close', 'resolve', 'add-journal', 'in-progress-incident', 'resolve-incident', 'acknowledge', 'unacknowledge', 'create-service-ticket', 'add-discussion-note-to-ticket', 'add-resolution-note-to-ticket', 'add-internal-note-to-ticket', 'close-service-ticket', 'in-progress-ticket', 'custom-status', 'add-note', 'confirm-incident', 'set-status-to-closed', 'set-status-to-pending', 'set-status-to-resolved', 'create-ticket', 'add-public-note', 'add-private-note', 'set-status-to-open', 'create-issue', 'add-comment-to-issue', 'in-progress-issue', 'close-issue', 'issue-done', 'add-tag', 'create-conversation', 'set-status-to-completed', 'ack-alert', 'unmute-alert', 'send-to-channel', 'create-case', 'set-case-status-to-active', 'set-case-status-to-close', 'set-case-status-to-close-as-duplicate', 'post-action-to-oec', 'create-alert', 'close-alert', 'acknowledge-alert', 'unacknowledge-alert', 'acknowledgeSensor', 'setStatusToClosed', 'set-case-status-to-working', 'add-note-to-incident', 'assign-to-group', 'assign-to-user', 'assign-to-owner', 'send-to-custom-endpoint', 'acknowledge-notification', 'createEvent', 'createTag', 'createComment', 'updateSeverity', 'updateStatusToClosed', 'updateStatusToInProgress', 'create-incident-and-update-component-statuses', 'resolve-incident-and-update-component-statuses-back-to-operational', 'update-component-statuses', 'sendData', 'postToUrl', 'add-internal-note', 'public-reply', 'set-status-to-solved'])
      unless validator.valid?(mapped_action)
        fail ArgumentError, 'invalid value for "mapped_action", must be one of #{validator.allowable_values}.'
      end
      @mapped_action = mapped_action
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          action == o.action &&
          extra_field == o.extra_field &&
          extra_field_for_mapped_action == o.extra_field_for_mapped_action &&
          mapped_action == o.mapped_action
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [action, extra_field, extra_field_for_mapped_action, mapped_action].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = OpsgenieSdk.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end
end
