=begin
#Opsgenie REST API

#Opsgenie OpenAPI Specification

OpenAPI spec version: 2.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.13

=end

require 'date'

module OpsgenieSdk
  class User
    attr_accessor :id

    attr_accessor :username

    attr_accessor :full_name

    # Role of user. It may be one of owner, admin, user or the name of a custom role you've created.
    attr_accessor :role

    # Skype username of the user
    attr_accessor :skype_username

    # Timezone of the user. If not set, timezone of the customer will be used instead.
    attr_accessor :time_zone

    # Location information of the user. If not set, locale of the customer will be used instead.
    attr_accessor :locale

    # Address of the user
    attr_accessor :user_address

    # List of labels attached to the user. You can label users to differentiate them from the rest. For example, you can add ITManager tag to differentiate people with this role from others.
    attr_accessor :tags

    # Set of user defined properties.
    attr_accessor :details

    attr_accessor :blocked

    attr_accessor :verified

    attr_accessor :created_at

    attr_accessor :muted_until

    attr_accessor :user_contacts

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'id' => :'id',
        :'username' => :'username',
        :'full_name' => :'fullName',
        :'role' => :'role',
        :'skype_username' => :'skypeUsername',
        :'time_zone' => :'timeZone',
        :'locale' => :'locale',
        :'user_address' => :'userAddress',
        :'tags' => :'tags',
        :'details' => :'details',
        :'blocked' => :'blocked',
        :'verified' => :'verified',
        :'created_at' => :'createdAt',
        :'muted_until' => :'mutedUntil',
        :'user_contacts' => :'userContacts'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'id' => :'String',
        :'username' => :'String',
        :'full_name' => :'String',
        :'role' => :'UserRole',
        :'skype_username' => :'String',
        :'time_zone' => :'String',
        :'locale' => :'String',
        :'user_address' => :'UserAddress',
        :'tags' => :'Array<String>',
        :'details' => :'Hash<String, Array<String>>',
        :'blocked' => :'BOOLEAN',
        :'verified' => :'BOOLEAN',
        :'created_at' => :'DateTime',
        :'muted_until' => :'DateTime',
        :'user_contacts' => :'Array<UserContact>'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      if attributes.has_key?(:'id')
        self.id = attributes[:'id']
      end

      if attributes.has_key?(:'username')
        self.username = attributes[:'username']
      end

      if attributes.has_key?(:'fullName')
        self.full_name = attributes[:'fullName']
      end

      if attributes.has_key?(:'role')
        self.role = attributes[:'role']
      end

      if attributes.has_key?(:'skypeUsername')
        self.skype_username = attributes[:'skypeUsername']
      end

      if attributes.has_key?(:'timeZone')
        self.time_zone = attributes[:'timeZone']
      end

      if attributes.has_key?(:'locale')
        self.locale = attributes[:'locale']
      end

      if attributes.has_key?(:'userAddress')
        self.user_address = attributes[:'userAddress']
      end

      if attributes.has_key?(:'tags')
        if (value = attributes[:'tags']).is_a?(Array)
          self.tags = value
        end
      end

      if attributes.has_key?(:'details')
        if (value = attributes[:'details']).is_a?(Hash)
          self.details = value
        end
      end

      if attributes.has_key?(:'blocked')
        self.blocked = attributes[:'blocked']
      end

      if attributes.has_key?(:'verified')
        self.verified = attributes[:'verified']
      end

      if attributes.has_key?(:'createdAt')
        self.created_at = attributes[:'createdAt']
      end

      if attributes.has_key?(:'mutedUntil')
        self.muted_until = attributes[:'mutedUntil']
      end

      if attributes.has_key?(:'userContacts')
        if (value = attributes[:'userContacts']).is_a?(Array)
          self.user_contacts = value
        end
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      true
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          id == o.id &&
          username == o.username &&
          full_name == o.full_name &&
          role == o.role &&
          skype_username == o.skype_username &&
          time_zone == o.time_zone &&
          locale == o.locale &&
          user_address == o.user_address &&
          tags == o.tags &&
          details == o.details &&
          blocked == o.blocked &&
          verified == o.verified &&
          created_at == o.created_at &&
          muted_until == o.muted_until &&
          user_contacts == o.user_contacts
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [id, username, full_name, role, skype_username, time_zone, locale, user_address, tags, details, blocked, verified, created_at, muted_until, user_contacts].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = OpsgenieSdk.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end
end
